<?php

namespace Drupal\languagewire_translation_provider\Test\Builder\ClientLibrary;

use Drupal\languagewire_translation_provider\api\Project\Assignment;
use Drupal\languagewire_translation_provider\api\Project\AssignmentDocument;
use Drupal\languagewire_translation_provider\api\Project\AssignmentStatus;

/**
 * Assignment Builder .
 */
class AssignmentBuilder {

  /**
   * Assignment Id .
   *
   * @var int
   */
  private $assignmentId = 1;

  /**
   * Source Language .
   *
   * @var string
   */
  private $sourceLanguage = 'pl';

  /**
   * Target Language .
   *
   * @var string
   */
  private $targetLanguage = 'dk';

  /**
   * Status .
   *
   * @var \Drupal\languagewire_translation_provider\api\Project\AssignmentStatus
   */
  private $status;

  /**
   * Assignment Documents .
   *
   * @var array
   */
  private $assignmentDocuments = [];

  /**
   * Constructs a new AssignmentBuilder object.
   */
  public function __construct() {
    $this->status = new AssignmentStatus(AssignmentStatus::IN_PROGRESS);
  }

  /**
   * With Assignment Document .
   */
  public function withAssignmentDocument(AssignmentDocument $assignmentDocument): self {
    $this->assignmentDocuments[] = $assignmentDocument;
    return $this;
  }

  /**
   * Build .
   */
  public function build(): Assignment {
    return new Assignment(
          $this->assignmentId,
          $this->sourceLanguage,
          $this->targetLanguage,
          $this->status,
          $this->assignmentDocuments
      );
  }

}
