<?php

namespace Drupal\languagewire_translation_provider\Test\Fakes;

use Drupal\languagewire_translation_provider\Adapter\TMGMT\LanguageMapping;
use Drupal\languagewire_translation_provider\Date;
use Drupal\languagewire_translation_provider\Platform\Services\ServiceInterface;
use Drupal\languagewire_translation_provider\Settings\JobSettings;

/**
 * Fake Service.
 */
class FakeService implements ServiceInterface {

  /**
   * ID .
   *
   * @var int
   */
  private $id;

  /**
   * Name .
   *
   * @var string
   */
  private $name;

  /**
   * Translation Memory .
   *
   * @var int
   */
  private $translationMemory;

  /**
   * Invoicing Account .
   *
   * @var int
   */
  private $invoicingAccount;

  /**
   * Work Area .
   *
   * @var int
   */
  private $workArea;

  /**
   * Deadline .
   *
   * @var \Drupal\languagewire_translation_provider\Date
   */
  private $deadline;

  /**
   * Constructs a new FakeService object.
   */
  public function __construct(int $id, string $name, int $translationMemory, int $invoicingAccount, int $workArea, Date $deadline) {

    $this->id = $id;
    $this->name = $name;
    $this->translationMemory = $translationMemory;
    $this->invoicingAccount = $invoicingAccount;
    $this->workArea = $workArea;
    $this->deadline = $deadline;
  }

  /**
   * Id .
   */
  public function id(): int {
    return $this->id;
  }

  /**
   * Name .
   */
  public function name(): string {
    return $this->name;
  }

  /**
   * Translation Memory Id.
   */
  public function translationMemoryId(): int {
    return $this->translationMemory;
  }

  /**
   * Invoicing Account Id .
   */
  public function invoicingAccountId(): int {
    return $this->invoicingAccount;
  }

  /**
   * Work Area Id .
   */
  public function workAreaId(): int {
    return $this->workArea;
  }

  /**
   * Deadline .
   */
  public function deadline(): Date {
    return $this->deadline;
  }

  /**
   * Configure .
   */
  public function configure(JobSettings $jobSettings): void {
  }

  /**
   * Is Language Supported .
   */
  public function isLanguageSupported(LanguageMapping $languageMapping): bool {
  }

}
